import { Component, EventEmitter, Input, OnDestroy, OnChanges, OnInit, Output, ApplicationRef } from '@angular/core';

@Component({
  selector: 'app-form',
  templateUrl: './form.component.html',
  styleUrls: ['./form.component.css']
})
export class FormComponent implements OnInit, OnChanges, OnDestroy {

  picArr = {
    cat: {
      start: "",
      record: "",
      wait: "",
      finish: "",
    },
    tryagain: {
      one: "",
      two: "",
      three: "",
    },
    list: [],
  };
  _item: any;
  KEY = 'hw_op52';
  errs = [];

  // @Input()
  set item(item) {
    this._item = item;
    // this.init();
  }
  get item() {
    return this._item;
  }

  @Output()
  update = new EventEmitter();



  constructor(private appRef: ApplicationRef) {

  }


  ngOnInit() {

    this.item = {};
    this.item.contentObj = {};

    const getData = (<any>window).courseware.getData;
    getData((data) => {

      if (data) {
        this.item = data;
      } else {
        this.item = {};
      }

      if (!this.item.contentObj) {
        this.item.contentObj = {};
      }

      console.log('~data:', data);
      this.init();
      this.refresh();

    }, this.KEY);

    // this.initData();
  }
  ngOnChanges() {

  }

  ngOnDestroy() {
  }


  classItem() {
    function AniAssets() {
      this.ske = {};
      this.tex = {};
      this.png = {};
      this.setData = function (obj) {
        this.ske = obj.ske;
        this.tex = obj.tex;
        this.png = obj.png;
      }
    }

    function Item() {
      this.title = "";
      this.titleRed = [];
      this.titleObj = [];
      this.bgImg = "";
      this.wordAudio = "";
      this.imgAni = new AniAssets();
    }

    return new Item();
  }
  onChoseRed(arr, i, val, item) {
    console.log(arr);
    arr[i] = val;
    item.titleObj = item.title.split("").map((s, idx) => {
      return {
        card: s,
        color: item.titleRed[idx] == 1 ? 0 : 1,
        audio: null,
      }
    })
    this.save();
  }


  init() {
    //在卡片组之上需要增加 两个组 0根->picArr  1题组->testlet  2页面->page  3卡片对->itemData
    if (this.item.contentObj.picArr) {
      this.picArr = this.item.contentObj.picArr;
      this.check();
    } else {
      this.picArr = this.getDefaultPicArr();
      this.item.contentObj.picArr = this.picArr;
    }
    console.log('item:', this.item);
  }

  cardItemData() {
    return this.classItem()
  }

  getDefaultPicArr() {
    let cat = {
      start: "",
      record: "",
      wait: "",
      finish: "",
    }
    let tryagain = {
      one: "",
      two: "",
      three: "",
    }
    let list = [this.classItem()]
    return { cat: cat, tryagain: tryagain, list: list };
  }

  initData() {


  }

  onDragonBoneSave(e, item) {
    console.log(e);
    this.save();
  }

  onImageUploadSuccessByItem(e, item) {
    item.bgImg = e.url;
    this.save();
  }

  onAudioUploadSuccessByItem(e, item) {
    item.wordAudio = e.url;
    this.save();
  }
  onAudioUploadSuccess(e, item, key) {
    item[key] = e.url;
    this.save();
  }

  //添加一对
  addItem() {
    //最多4个 
    let item = this.cardItemData();
    this.picArr.list.push(item)
    this.saveItem();
  }
  deleteItem(i) {
    this.picArr.list.splice(i, 1);
    this.save();
  }

  //添加一对
  addObj(i) {
    //最多4个 
    this.picArr.list[i].titleObj.push({
      card: '',
      color: 0,
      audio: null,
    })
    this.saveItem();
  }
  deleteObj(i, o) {
    this.picArr.list[i].titleObj.splice(o, 1);
    this.save();
  }




  //选择圆圈
  radioClick(it, radioValue) {
    it.radioValue = radioValue;
    this.saveItem();
  }


  saveItem() {

    console.log(' in saveItem');
    // this.update.emit(this.item);
    this.save();
  }

  check() {
    if (!this.picArr) return;
    this.errs.length = 0;
    console.log("this.errs");
    console.log(this.errs);
    console.log("-------------------------");
  }


  save() {
    //触发一次检测
    this.check();
    (<any>window).courseware.setData(this.item, null, this.KEY);
    console.log('this.item = ' + JSON.stringify(this.item));
    this.refresh();
  }

  refresh() {
    setTimeout(() => {
      this.appRef.tick();
    }, 1);
  }
}

